package org.jeecg.modules.energy.controller;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.apache.commons.lang.StringUtils;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.config.mybatis.ThreadLocalDataHelper;
import org.jeecg.modules.device.entity.BuDevice;
import org.jeecg.modules.device.service.IBuDeviceService;
import org.jeecg.modules.energy.entity.BuAirSmoke;
import org.jeecg.modules.energy.entity.BuElectric;
import org.jeecg.modules.energy.service.IBuAirSmokeService;
import org.jeecg.modules.sensor.entity.BuSensor;
import org.jeecg.modules.sensor.entity.BuSensorType;
import org.jeecg.modules.sensor.service.IBuSensorService;
import org.jeecg.modules.sensor.service.IBuSensorTypeService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: bu_air_smoke_online
 * @Author: jeecg-boot
 * @Date:   2024-10-11
 * @Version: V1.0
 */
@Api(tags="bu_air_smoke_online")
@RestController
@RequestMapping("/energy/buAirSmoke")
@Slf4j
public class BuAirSmokeController extends JeecgController<BuAirSmoke, IBuAirSmokeService> {
	@Autowired
	private IBuAirSmokeService buAirSmokeService;
	@Autowired
	private IBuSensorService buSensorService;
	@Autowired
	private IBuDeviceService buDeviceService;
	@Autowired
	private IBuSensorTypeService buSensorTypeService;
	/**
	 * 分页列表查询
	 *
	 * @param buAirSmoke
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "bu_air_smoke_online-分页列表查询")
	@ApiOperation(value="bu_air_smoke_online-分页列表查询", notes="bu_air_smoke_online-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<BuAirSmoke>> queryPageList(BuAirSmoke buAirSmoke,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {

		BuDevice buDevice = buDeviceService.getById(buAirSmoke.getDeviceId());
		List<BuSensor> buSensors = buSensorService.getByCheckName(buDevice.getId(),"%烟雾%");
		BuSensorType buSensorType = buSensorTypeService.getById(buSensors.get(0).getTypeId());
		String tableName = "";
		if(buAirSmoke.getBeginTime()!=null){
			String substring = buAirSmoke.getBeginTime().substring(0, buAirSmoke.getBeginTime()
					.indexOf("-", buAirSmoke.getBeginTime().indexOf("-") + 1)).replaceAll("-","");

//			tableName = buSensorType.getTableHead() + "_history_" + buDevice.getTypeId() + "_" + buDevice.getDeviceCode() + "_" + substring;
			tableName = buSensorType.getTableHead() + "_history_" + substring;
		}
		ThreadLocalDataHelper.put("bu_smoke_online",tableName);

//		QueryWrapper<BuAirSmoke> queryWrapper = QueryGenerator.initQueryWrapper(buAirSmoke, req.getParameterMap());
		LambdaQueryWrapper<BuAirSmoke> queryWrapper = new LambdaQueryWrapper<>();
		if(buAirSmoke.getDeviceId()!=null){
			LambdaQueryWrapper<BuSensor> lambdaQueryWrapper = new LambdaQueryWrapper<>();
			lambdaQueryWrapper.eq(BuSensor::getDeviceId,buAirSmoke.getDeviceId());
			List<String> codeList = buSensorService.list(lambdaQueryWrapper).stream().map(BuSensor::getId).collect(Collectors.toList());
			queryWrapper.in(BuAirSmoke::getSensorId,codeList);
		}
		if(buAirSmoke.getSensorId()!=null){
			queryWrapper.eq(BuAirSmoke::getSensorId,buAirSmoke.getSensorId());
		}
		if (StringUtils.isNotBlank(buAirSmoke.getBeginTime()) && StringUtils.isNotBlank(buAirSmoke.getEndTime())){
			queryWrapper.between(BuAirSmoke::getCreateTime,buAirSmoke.getBeginTime(),buAirSmoke.getEndTime());
		}
		if (StringUtils.isNotBlank(buAirSmoke.getInTime()) && StringUtils.isNotBlank(buAirSmoke.getOutTime())){
			queryWrapper.between(BuAirSmoke::getCreateTime,buAirSmoke.getInTime(),buAirSmoke.getOutTime());
		}
		queryWrapper.orderByDesc(BuAirSmoke::getCreateTime);
		Page<BuAirSmoke> page = new Page<BuAirSmoke>(pageNo, pageSize);
		page.setOptimizeCountSql(false);
		IPage<BuAirSmoke> pageList = buAirSmokeService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	@AutoLog(value = "烟雾传感器数据-首页查询")
	@ApiOperation(value="烟雾传感器数据-首页查询", notes="烟雾传感器数据-首页查询")
	@GetMapping(value = "/getAirSmokeData")
	public Result<?> getAirSmokeData() {
		List<BuAirSmoke> buAirSmokeList = buAirSmokeService.getAirSmokeData();
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		for (BuAirSmoke buAirSmoke : buAirSmokeList) {
			buAirSmoke.setDeviceName(buAirSmoke.getDeviceName()+buAirSmoke.getDeviceCode());
		}
		return Result.OK(buAirSmokeList);
	}
	
	/**
	 *   添加
	 *
	 * @param buAirSmoke
	 * @return
	 */
	@AutoLog(value = "bu_air_smoke_online-添加")
	@ApiOperation(value="bu_air_smoke_online-添加", notes="bu_air_smoke_online-添加")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_air_smoke_online:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody BuAirSmoke buAirSmoke) {
		buAirSmokeService.save(buAirSmoke);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param buAirSmoke
	 * @return
	 */
	@AutoLog(value = "bu_air_smoke_online-编辑")
	@ApiOperation(value="bu_air_smoke_online-编辑", notes="bu_air_smoke_online-编辑")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_air_smoke_online:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody BuAirSmoke buAirSmoke) {
		buAirSmokeService.updateById(buAirSmoke);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "bu_air_smoke_online-通过id删除")
	@ApiOperation(value="bu_air_smoke_online-通过id删除", notes="bu_air_smoke_online-通过id删除")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_air_smoke_online:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		buAirSmokeService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "bu_air_smoke_online-批量删除")
	@ApiOperation(value="bu_air_smoke_online-批量删除", notes="bu_air_smoke_online-批量删除")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_air_smoke_online:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.buAirSmokeService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "bu_air_smoke_online-通过id查询")
	@ApiOperation(value="bu_air_smoke_online-通过id查询", notes="bu_air_smoke_online-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<BuAirSmoke> queryById(@RequestParam(name="id",required=true) String id) {
		BuAirSmoke buAirSmoke = buAirSmokeService.getById(id);
		if(buAirSmoke==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(buAirSmoke);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param buAirSmoke
    */
    //@RequiresPermissions("org.jeecg.modules.demo:bu_air_smoke_online:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BuAirSmoke buAirSmoke) {
        return super.exportXls(request, buAirSmoke, BuAirSmoke.class, "bu_air_smoke_online");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("bu_air_smoke_online:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BuAirSmoke.class);
    }

}
